#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

# --------------------------------------------------------------
#
# Modification History:
#
# Date    Author Comment
# ======= ====== ===============================================
# 06Oct03 BB     Added debugging code at the end
# 25Apr04 BB     1.13 Added code to capture the rsh service type
# 1.15 14May04 bb - New NTRESKIT code. Now, try to find it in the default pat
# 1.16 05Aug04 bb - New code for 9i connection
# 1.17 29Oct04 bb - New code to find the listener password
# 1.18 17Jan05 bb - New perf subroutine, and much syntax cleanup 
# 1.19 26Jan05 bb - Added spfile logic
# --------------------------------------------------------------
$version = "1.19";
$verdate = "26Jan05";

use Win32::Registry;
use Time::Local;

$debug = 0;
$| = 1;
#$# = 2;
$P = "dbamon_orant.pl";


$db_user = "internal";
$pass = "";

$os   = $ARGV[0];
$verb = $ARGV[1];
$arg1 = $ARGV[2];
$arg2 = $ARGV[3];
$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

$WWW = 1 if $arg1 eq "WWW";

### Get hostname
%values="";
$Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
   $RegType      = $values{$value}->[1];
   $RegValue     = $values{$value}->[2];
   $RegKey       = $values{$value}->[0];
   $hostname = $RegValue if $RegKey eq "Hostname";
}
$hkey->Close();
$host = $hostname;
$numcpus = $ENV{"NUMBER_OF_PROCESSORS"};

if ($host eq "wcoslgl3" || $host eq "nbbnas05")
{
  $db_user = "system";
}

# Save Company name
open(NSLOOKUP, 'ipconfig/all|') || die "Error running ipconfig";
while(<NSLOOKUP>)
{
  ##print;
  @words = split;
  $verb1 = $words[0];
  $verb2 = $words[1];
  ##print "verb1=$verb1 verb2=$verb2\n";
  if ($verb1 eq "Host" && $verb2 eq "Name")
  {
    $compwork = $words[$#words]; 
    ##print "compwork=$compwork\n";
  }
}
close(NSLOOKUP);
chop $compwork;
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];
##print "$P | Company: $company\n";

$userid = Win32::LoginName();
$driver = "DBAmonOracle$os";

if ($os eq "")
{
  print "$P | Error: No OracleSID supplied\n";
  &msg("END_OF_PROBE");
  exit 1;
}
if ($verb eq "")
{
  print "$P | Error: No verb supplied\n";
  &msg("END_OF_PROBE");
  exit 1;
}

$sid_found = "false";

### Get list of sids that exist
%values="";
$Register = "SYSTEM\\CurrentControlSet\\Services";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey) || die "Cannot open registry $Register -$!";
$hkey->GetKeys(\@key_list);
$hkey->Close();

foreach $RegKey (@key_list)
{
  if ($RegKey =~ "OracleService")
  {
    $sid_cnt+=1;
    $sid_length = length ($RegKey);
    $sid = uc(substr ($RegKey,13,$sid_length));
    $sid_list .= "$sid ";
    if ($sid eq $os)
    {
      $sid_found = "true";
    }
  }
}
&msg("Found $sid_cnt total Oracle instances on this server: $sid_list");

if ($sid_found eq "false")
{
  &error("\"$os\" not present -- OracleService$os not found\n");
}

### Get ORACLE_HOME
%values="";
$Register = "SYSTEM\\CurrentControlSet\\Services\\OracleService$os";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey) || die "Cannot open registry $Register -$!";
$hkey->GetValues(\%values);
$hkey->Close();

foreach $value (keys(%values))
{
   $RegKey   = $values{$value}->[0];
   $RegType  = $values{$value}->[1];
   $RegValue = $values{$value}->[2];
   $RegKey = lc($RegKey);

   if ($RegKey eq "imagepath")
   {
      @words = split (/\\/,$RegValue);
      $start_cmd = $words[-1];
      $_=$RegValue;
      s/$start_cmd//;
      s/bin//;
      $oh=$_;
      chop($oh);
      chop($oh);
      # print "ORACLE_HOME: $oh\n";
   }
}

#---- See if PW is set for this driver 
%values="";
$Register = "Software\\ODBC\\ODBC.INI\\$driver";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| &msg("Cannot open registry $Register - $!");
if ($hkey)
{
  $hkey->GetValues(\%values) || print "Cannot read registry $Register - $!";
  foreach $value (keys(%values))
  {
     $RegType      = $values{$value}->[1];
     $RegValue     = $values{$value}->[2];
     $RegKey       = $values{$value}->[0];
     $syspw = $RegValue if $RegKey eq "Password";
  }
$hkey->Close();
}

#---- Capture oraver
$oraver     = (split(" ",`sqlplus -v`)) [2];
$oraver_fam = (split('\.',$oraver)) [0];

&msg("Note: oraver ($oraver) is NG") if $oraver < 1;

if ($oraver_fam > 8)
{
  $db_user = "";
  $pass    = "/ as sysdba";
  $sqlcmd = "sp";
}
else
{
  $sqlcmd = "sv";
}

if ($syspw)
{
  $db_user = "";
  $pass    = "";
}

#---- Get oradrive
$oradrive = substr($oh,0,2); 

#---- See if srvinfo is in the system path
if (system("srvinfo -ns >NUL") == 0)
{
  $srvinfo_path = "srvinfo";
}
else
{
  if ($ENV{'NTRESKIT'})
  {
    $srvinfo_path = "$ENV{'NTRESKIT'}\\srvinfo";
  }
  else
  {
    &msg("Hmmmm... Could not find srvinfo in default path and NTRESKIT not in env");
    ##system("$PERLPATH C:\\dbatools\\socketmail.pl dbaadmin\@dba.it.agilent.com dbaadmin\@dba.it.agilent.com \"dbamon_mssql.pl Cannot find srvinfo host=$host [AUTO]\" \"Hi\"");
  }
}

$tmpsql = "\\temp\\dbamon_orant_sql_${os}.sql";

#---- Set ORACLE_SID to $os
$ENV{'ORACLE_SID'} = $os; 
$ENV{'ORACLE_HOME'} = $oh; 

#---- Display banner
&msg("Starting - host=$host os=$os oh=$oh userid=$userid verb=$verb driver=$driver version=$version company=$company debug=$debug");
&msg("Starting - arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 WWW=$WWW oraver=$oraver oraver_fam=$oraver_fam sqlcmd=$sqlcmd db_user=$db_user pass=$pass oradrive=$oradrive srvinfo_path=$srvinfo_path");

#---- Take these out for now - BB 14May04
#if ($host eq "csenv01") { $ENV{'NTRESKIT'} = "c:\\reskit"; }
#if ($host eq "spgqremw") { $ENV{'NTRESKIT'} = "e:\\reskit"; }
#if ($host eq "wcoslgl3") { $ENV{'NTRESKIT'} = "e:\\reskit"; }
#if ($host eq "engcti1") { $ENV{'NTRESKIT'} = "d:\\ntreskit"; }
#if ($host eq "cslsnt02") { $ENV{'NTRESKIT'} = "d:\\reskit"; }
#if ($host eq "wsccbp02") { $ENV{'NTRESKIT'} = "c:\\bin"; }
#if ($host eq "wsccbp02") { $ENV{'NTRESKIT'} = "c:\\bin"; }
#if ($host eq "wwadap02") { $ENV{'NTRESKIT'} = "c:\\reskit"; }

# Add $oh/bin to path
$path_orig   = $ENV{'Path'};
$path_new    = "${oh}/bin;" . $path_orig;
$ENV{"Path"} = $path_new;

# See if there is a pw file - if there is then use that as the pw
$f = "$oh\\net80\\admin\\.system";
if (-r "$f")
{
  $/="\n";
  chomp($pass = `type $f`);
  print "$P | Access shortcut ON \n";
}


# --------------------------------------------------------------
#
# Subroutines
#
# --------------------------------------------------------------

#------------------------------------------------------------------------------
sub timeToNum
#------------------------------------------------------------------------------
{
  $zz_text = $_[0];
  $zz_text =~ s/-/\//g;
  $zz_text =~ s/:/\//g;
  ##print "zz_text=$zz_text\n";
  @words = split(/\//,$zz_text);

  if ($#words != 5)
  {
    &error("Input Target_End_Time ($zz_text) should be in the format: YYYY/MM/DD-HH:MM:SS","DOC116");
  }

  $zz_yyyy = $words[0];
  $zz_mon  = $words[1];
  $zz_dd   = $words[2];
  $zz_hh   = $words[3];
  $zz_mm   = $words[4];
  $zz_ss   = $words[5];
  ##print "zz_yyyy=$zz_yyyy zz_mon=$zz_mon zz_dd=$zz_dd zz_hh=$zz_hh zz_mm=$zz_mm zz_ss=$zz_ss\n";

  &error("Input Target_End_Time - YYYY must be 2002-2099","DOC116") if ($zz_yyyy < 2002 || $zz_yyyy > 2099);
  &error("Input Target_End_Time - MON  must be 1-12     ","DOC116") if ($zz_mon  <    1 || $zz_mon  >   12);
  &error("Input Target_End_Time - DD   must be 1-31     ","DOC116") if ($zz_dd   <    1 || $zz_dd   >   31);
  &error("Input Target_End_Time - HH   must be 0-23     ","DOC116") if ($zz_hh   <    0 || $zz_hh   >   23);
  &error("Input Target_End_Time - MM   must be 0-59     ","DOC116") if ($zz_mm   <    0 || $zz_mm   >   59);
  &error("Input Target_End_Time - SS   must be 0-59     ","DOC116") if ($zz_ss   <    0 || $zz_ss   >   59);

  @zz_date=($zz_ss,$zz_mm,$zz_hh,$zz_dd,--$zz_mon,$zz_yyyy);
  $zz_result = &timelocal(@zz_date);

  return $zz_result;
}

sub dbError 
{
  #unused# local($errorMsg,@error_fields) = @_;
  local($errorMsg) = @_;
  print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
  print "Error: DB Error Encountered While: $errorMsg\n";
  print "Error: DB Error String: $DBI::errstr\n";
  print "==========================================================\n";
  $dberror = 1;
  &msg("END_OF_PROBE");
  exit 1;
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  print "\n";
  print "$P | Fatal Error: $msg\n";
  print "Error: $msg\n";
  #$date = `date`;
  print "$P | Exiting\n";
  &msg("END_OF_PROBE");
  exit 1;
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  $date = &get_date("Y/M/D-H:M:S");
  print "$date ${P} $version/$verdate | $msgmsg\n";
}


#------------------------------------------------------------------------------
sub get_date
#------------------------------------------------------------------------------
{
  # Return date in format supplied as argument. Valid formats are:
  #   Y/M/D-H:M:S
  #   YMD_HMS
  #   YMD

  $format = $_[0];

  @sysdate = localtime;
  for ($i = 0; $i <= 5; $i++)
  {
    if ($sysdate[$i] < 10)
    {
      $sysdate[$i] = 0 . $sysdate[$i];
    }
  }

  if ($format eq "Y/M/D-H:M:S")
  {
    $sysdate = $sysdate[5]+1900 . "/" . ++$sysdate[4] . "/" . $sysdate[3] . "-" . $sysdate[2] . ":" . $sysdate[1] . ":" . $sysdate[0];
  }
  elsif ($format eq "YMD_HMS")
  {
    $sysdate = $sysdate[5]+1900 . ++$sysdate[4] . $sysdate[3] . "_" . $sysdate[2] . $sysdate[1] . $sysdate[0];
  }
  elsif ($format eq "YMD")
  {
    $sysdate = $sysdate[5]+1900 . ++$sysdate[4] . $sysdate[3];
  }
  else
  {
    &error("Invalid format passed to get_date. Must be Y/M/D-H:M:S or YMD_HMS");
  }
  return $sysdate;
}


# ----------------------------------------------------------------------
sub datafiles
# ----------------------------------------------------------------------
{
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";

  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  # Read from v$datafile;
  $sql = "select 
      d.name, 
      t.name,
      d.status
    from 
      v\$datafile d,
      v\$tablespace t
    where 
      d.ts# = t.ts# and
      status != 'SYSTEM' and 
      status != 'ONLINE'";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  print "\n";
  while (@Data = $sth->fetchrow_array)
  {
    $dfname = $Data[0];
    $tsname = $Data[1];
    $status = $Data[2];
    print "OfflineDatafile: Tablespace=$tsname DFName=$dfname DFStatus=$status\n";
  }
  print "\n";
}

# ----------------------------------------------------------------------
sub ts      
# ----------------------------------------------------------------------
{
  $t_warn = $arg1;
  $t_crit = $arg2;
  $t_free = $arg3;
  #unused#$t_cmd  = $arg4;

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";

  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    $sql = "
     select 
	    a.tablespace_name as tablespace_name,
	    d.contents,
	    a.sum_bytes as bytes_avail,
	    a.max_id,
	    nvl(b.sum_bytes,0) as bytes_used,
	    nvl(c.sum_bytes,0) as bytes_free,
	    round(nvl(b.sum_bytes,0.00) / a.sum_bytes * 100.0, 2) as pct_used,
	    d.status
       from 
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes,
		count(1) max_id
	      from 
		dba_data_files
	      group by 
		tablespace_name
	    ) a,
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes
	      from 
		dba_extents
	      group by 
		tablespace_name
	    ) b,
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes
	      from 
		dba_free_space
	      group by 
		tablespace_name
	    ) c,
	    dba_tablespaces d
      where a.tablespace_name = b.tablespace_name (+)
	and a.tablespace_name = c.tablespace_name (+)
	and a.tablespace_name = d.tablespace_name (+)
      ";

    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
   
    $verb = "Stack: orantTSStack";

    while (@Data = $sth->fetchrow_array)
    {
      $ts   = $Data[0];
      $type = substr($Data[1],0,4);
      $size = $Data[2]/1048576;
      $max  = $Data[3];
      $used = $Data[4]/1048576;
      $free = $Data[5]/1048576;
      $pct  = $Data[6];
      #unused#$stat = $Data[7];

      $sth2 = $dbh->prepare("select max(autoextensible) from dba_data_files where tablespace_name = '$ts'") || &dbError("Prepare");
      $sth2->execute || &dbError("Execute_Select");
      while (@Data2 = $sth2->fetchrow_array)
      {
	$autoextend = $Data2[0];
      }

      ##print "ts=$ts autoextend=$autoextend \n";

      $flag = "";
      # MB Needed to get to 5% below warning threshold
      $needed = int($used / (($t_warn-5)/100) - $size);
      if ($needed < 100)
      {
        $needed = 50;
      }
      if ($needed > 2000)
      {
        $needed = 2000;
      }
      
      if ($pct  >= $t_warn && $pct < $t_crit) { $flag = "W" . " " . $needed; }
      if ($pct  >= $t_crit )                  { $flag = "C" . " " . $needed; }
      if ($free >= $t_free)                   { $flag = "";  }
      if ($autoextend eq "YES") { $flag = "A"; } 

      ##print "ts=$ts pct=$pct t_warn=$t_warn t_crit=$t_crit flag=$flag \n";

      #printf("%s %-16s %8d %8d %8d %7.1f %s\n",$verb,$ts,$size,$used,$free,$pct,$flag);
      print "$verb $ts $type $max $size $used $free $pct $flag \n";
    }
    return;
  }
}

# ----------------------------------------------------------------------
sub arclogs
# ----------------------------------------------------------------------
{
  $t_warn = $arg1;
  $t_crit = $arg2;

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";

  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    # Read from v$database
    $sql = "select log_mode from v\$database";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      print "Log_Mode: $Data[0]\n";

      if ($Data[0] eq "NOARCHIVELOG")
      {
        &msg("This DB is in NOARCHIVELOG mode - not checking disk");
        return;
      }
    }

    # Read from v$archive_dest
    $sql = "select destination from v\$archive_dest where length(destination) > 0";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      print "Log_Dest: $Data[0]\n";
      $logdrive = uc substr($Data[0],0,1);
      $logdrivedollar = "$logdrive\$";
      print "Log_Drive: $logdrive\n";
      $logdrivecount++;
    }
    print "Log_Drive_Count: $logdrivecount\n";

    #$logdrivesize = (Win32::Driveinfo::DriveSpace($logdrive)) [5];
    #$logdrivefree = (Win32::Driveinfo::DriveSpace($logdrive)) [6];
    #print "size=$logdrivesize free=$logdrivefree \n";

    # See how full the $logdrive disk is 
    open(SRVINFO, "$srvinfo_path -ns|") || print "Error: Running $srvinfo_path";
    while(<SRVINFO>)
    {
      $srvinfo_ran = 1;
      print;
      @words = split;

      if ($words[0] eq $logdrivedollar) 
      {
        $srvinfo_found = 1;
        $logdrivesize = $words[2];
        $logdrivefree = $words[3];
        $logdriveused = $logdrivesize - $logdrivefree;
        $logdrivepct  = int(($logdriveused / $logdrivesize) * 100);
        print "Log_Drive_Size: $logdrivesize\n";
        print "Log_Drive_Free: $logdrivefree\n";
        print "Log_Drive_Used: $logdriveused\n";
        print "Log_Drive_Pct:  $logdrivepct\n";

        if    ($logdrivepct > $t_crit) { $logflag = "C"; }
        elsif ($logdrivepct > $t_warn) { $logflag = "W"; }
        else { $logflag = " "; }
        print "Log_Flag:  $logflag\n";
      }
    }
  } # end of !$dberror

  if (!$srvinfo_ran)
  {
    print "Log_Flag:  S   ($srvinfo_path (srvinfo) did not run)\n";
    system("set");
  }

  if (!$srvinfo_found)
  {
    print "Log_Flag:  S   ($srvinfo_path (srvinfo) did run, but did not find any information for disk $logdrivedollar - something is wrong)\n";
    print "\nNT Environment:\n";
    system("set");
  }
}

# ----------------------------------------------------------------------
sub controlFiles
# ----------------------------------------------------------------------
{
  #---- Read all driveletters from v$controlfile
  &msg("Checking controlfiles - Starting"); 

  $sql = "select name from v\$controlfile where name like '%:%'";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");

  $cfcount = 0;
  $cfdrives = "";
  $cfdrivecount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $cfname = $Data[0]; 
    $drive  = substr($cfname,0,1); 
    &msg("  Found cfname=$cfname drive=$drive");
    $cfcount++; 
    $cfdrives .= $drive if index($cfdrives,"$drive") == -1; 
  }

  $cfdrivecount = length($cfdrives); 

  print "$P CFDRIVES: $cfdrives\n"; 
  print "$P CFDRIVECOUNT: $cfdrivecount\n"; 
  print "$P CFCOUNT: $cfcount\n"; 

  &msg("Checking controlfiles - Done"); 
}

# ----------------------------------------------------------------------
sub redoLogs
# ----------------------------------------------------------------------
{
  #---- Read all driveletters from v$logfile
  &msg("Checking redologs - Starting"); 

  $sql = "select member from v\$logfile where member like '%:%'";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");

  $rlcount = 0;
  $rldrives = "";
  $rldrivecount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $rlname = $Data[0]; 
    $drive  = substr($rlname,0,1); 
    &msg("  Found rlname=$rlname drive=$drive");
    $rlcount++; 
    $rldrives .= $drive if index($rldrives,"$drive") == -1; 
  }

  $rldrivecount = length($rldrives); 

  print "$P RLDRIVES: $rldrives\n"; 
  print "$P RLDRIVECOUNT: $rldrivecount\n"; 
  print "$P RLCOUNT: $rlcount\n"; 

  &msg("Checking redologs - Done"); 
}

# ----------------------------------------------------------------------
sub up
# ----------------------------------------------------------------------
{
  %values="";
  $Register = "Software\\Microsoft\\Windows NT\\CurrentVersion";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $CurrentVersion = $RegValue if $RegKey eq "CurrentVersion";
    $CSDVersion = $RegValue if $RegKey eq "CSDVersion";
  }

  if ($CSDVersion ne "")
  {
    @sp_info = split(' ',$CSDVersion);
    $osver = $CurrentVersion . ",SP" . ${sp_info[2]};
  }
  else
  {
    $osver = $CurrentVersion;
  }

  %values="";
  $Register = "Hardware\\Description\\System\\CentralProcessor\\0";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $MHz = $RegValue if $RegKey eq "\~MHz";
    $vendor = $RegValue if $RegKey eq "VendorIdentifier";
    $identifier = $RegValue if $RegKey eq "Identifier";
  }
  $hkey->Close();
  @cpu_ident = split (' ',$identifier);
  $cpumodel = ${cpu_ident[0]} . "/" . ${cpu_ident[2]};
  $cpu = $vendor . " " . " " . $MHz . " MHz ";

  $cpumodel = $ENV{'PROCESSOR_ARCHITECTURE'} . "," . $ENV{'PROCESSOR_LEVEL'};

  if (!$WWW)
  {
    print "OSVer: $osver\n";
    print "NumCPUs: $ENV{'NUMBER_OF_PROCESSORS'}\n";
    print "CPU: $cpu\n";
    print "CPUModel: $cpumodel\n";
  }

  # Test
  open(SRVINFO, "$srvinfo_path -ns|") || print "Error: Running srvinfo";
  $uptime = "?";
  while(<SRVINFO>)
  {
    ##print;
    @words = split;

    if (/^System Up Time:/)
    {
      chop($uptime = substr($_,16));
    }
  }
  &msg("Ran srvinfo to capture uptime - uptime=$uptime");

  # Get memory Info
  print "$P Invoking pstat\n" if !$WWW;
  open(MEM, 'pstat 2>NUL |') 
    || print "$P Error $! Running pstat";
  while(<MEM>)
  {
    ##print;
    @words = split;
    $ram = int($words[4] / 1024);
    last;
  }
  close(MEM);
  if (defined($ram) && !$WWW)
  {
    print "RAM: $ram\n";
  }

  &msg("Invoking net start to see which services are running") if !$WWW;

  #---- See if the agent is running
  open(NET, 'net start |') || print "$P Error $! Running net start";

  $rsh_service = "?";

  while(<NET>)
  {
    ##print;
    @words = split;

    if (/TNSListener/)
    {
      $listener_running = 1;
      print "ListenerServiceRunning: Y\n" if !$WWW;
    }

    if (uc $words[0] eq uc "OracleService$os")
    {
      $service_running = 1;
      print "OracleServiceRunning: Y\n" if !$WWW;
    }

    if ($rsh_service eq "?")
    {
      if (/Remote Shell Daemon/)  { $rsh_service="RSD"; }
      if (/Remote Shell Service/) { $rsh_service="RSS"; }
      if (/CYGWIN sshd/)          { $rsh_service="CYGWIN"; }
    }
  }
  close(NET);

  &msg("After net start") if !$WWW;

  print "RSHService: $rsh_service\n" if !$WWW;

  if (!$service_running)
  {
    $dbstatus = "SERVICENOTACTIVE";
    print "DBStatus: $dbstatus\n" if !$WWW;
  }

  # See if the agent is running
  #  Determine the name of the lsnrctl program
  if (-x "$oh\\bin\\lsnrctl80.exe")
  {
    $lsnrpgm = "lsnrctl80"; 
  }
  else
  {
    $lsnrpgm = "lsnrctl"; 
  }
  &msg("Running $lsnrpgm") if !$WWW;

  #---- See if the listener.ora file contains a password
  #PASSWORDS_LISTENER = (pr0efx)
  open(LSNR,"$oh\\network\\admin\\listener.ora") || &error("Cannot OPEN listener.ora file");
  while (<LSNR>)
  {
    if (/^PASSWORDS_LISTENER/)
    {
      $listener_password = (split(/\=/,$_))[1];
      $listener_password =~ s/ //g;
      $listener_password =~ s/\(//g;
      $listener_password =~ s/\)//g;
      $listener_password =~ s/\n//g;
    }
  }
  close(LSNR);

  #---- Create temp listener commands file
  $listener_cmds = "\\temp\\dbamon_ora_listener_$os.txt";
  open (LSNRCMDS,">$listener_cmds") || &error("Cannot OPEN output $listener_cmds file");
  print LSNRCMDS "set password $listener_password\n" if $listener_password;
  print LSNRCMDS "status\n"; 
  print LSNRCMDS "exit\n"; 
  close(LSNRCMDS);

  ## &msg("Listener commands");
  ## system("type $listener_cmds");

  #---- New way
  #@lsnr_output = `type $listener_cmds | lsnrctl`;
  #foreach (@lsnr_output)
  #{
  #  print;
  #}
  #---- Old way
  #open(LSNR, "type $listener_cmds | $lsnrpgm |") || print "Error: Running $lsnrpgm status";
  #while(<LSNR>)

  &msg("Running $lsnrpgm with $listener_cmds");
  #---- New way
  @lsnr_output = `type $listener_cmds | $lsnrpgm`;
  #---- Remove temp file
  system("erase $listener_cmds");
  foreach (@lsnr_output)
  {
    print if !$WWW;
    $listener_output .= $_;

    #---- Old way
    #@words = split;
    #if (/command completed successfully/)
    #{
    #  $lsnrctl_running = 1;
    #  #last;
    #}

    #---- New way
    if (/Services Summary.../)
    {
      $lsnrctl_running = 1;
      #last;
    }
  }
  print "\n";

  $lsnr_status = "OK";
  if (!$lsnrctl_running) 
  {
    $lsnr_status = "LSNRCTL-NOT-OK";
  }
  if (!$listener_running) 
  {
    $lsnr_status = "LSNR-SERVICE-NOT-RUNNING";
  }

  print "LSNRStatus: $lsnr_status \n" if !$WWW;

  ##&bkup;

  if ($lsnr_status ne "OK")
  {
    &msg("Since the listener is not running properly, aborting further checks");
    if ($WWW) { exit 1; }
    return 1;
  }

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.

  &msg("Connecting to Oracle driver=$driver");

  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    # Read from dual
    &msg("Selecting from dual") if !$WWW;
    $sql = "select dummy from dual";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $dbdual = $Data[0];
      print "DBDual: $dbdual\n" if !$WWW;
    }

    # Read from v$instance
    &msg("Selecting from v\$instance") if !$WWW;
    $sql = "select 
      version, 
      status, 
      logins,
      to_char(startup_time,'YYYY/MM/DD-HH24:MI:SS')
    from 
      v\$instance";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $ver = $Data[0];
      $sta = $Data[1];
      $log = $Data[2];
      $str_c = $Data[3];

      if (!$WWW)
      {
	print "DBStatus: $sta\n";
	print "DBVersion: $ver\n";
	print "DBLogins: $log\n";
      }
    }

    if ($str_c)
    {
      $str_n = &timeToNum($str_c);
      $endc = $str_c;
      $calc_date = $date;
      $calc_time = time;

      $uptime_days  = sprintf("%.2f", (time - $str_n) / (24*60*60));
      $uptime_hours = sprintf("%.2f", (time - $str_n) / (60*60));
      
      if ($WWW ne "Y")
      {
        print "$P UPTIME:          $str_c $str_n $calc_date $calc_time\n";
      }
    }

    # Read from v$license
    &msg("Selecting from v\$license") if !$WWW;
    $sql = "select SESSIONS_HIGHWATER from v\$license";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $hwm = $Data[0];
      print "SESSIONSHWM: $hwm\n" if !$WWW;
    }

    # Get session userid
    &msg("Selecting from dual for user") if !$WWW;
    $sql = "select user from dual";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $user = $Data[0];
    }
    print "Current_User: $user\n" if !$WWW;

    # Get total bytes
    &msg("Selecting from dba_data_files to get size of instance");
    $sql = "select sum(bytes) from dba_data_files";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $tot_spacealloc = int($Data[0] / (1024*1024));
    }

    # Get total free
    &msg("Selecting from dba_free_space to get size of free space");
    $sql = "select sum(bytes) from dba_free_space";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $tot_spacefree = int($Data[0] / (1024*1024));
    }
    $tot_spaceused = $tot_spacealloc - $tot_spacefree;

    if (!$WWW)
    {
      print "SpaceFree:  $tot_spacefree\n";
      print "SpaceAlloc: $tot_spacealloc\n";
      print "SpaceUsed:  $tot_spaceused\n";
    }
 
  } # end of !$dberror

  # Decide status
  $dbstatus = "DOWN";

  if ($service_running && $dbdual eq "X" && $sta eq "OPEN")
  {
    $dbstatus = "UP";
  }
  if ($service_running && $log eq "RESTRICTED")
  {
    $dbstatus = "RESTRICTED";
  }
  if ($service_running && $dbdual ne "X")
  {
    $dbstatus = "SQLERROR";
  }

  print "DBStatus: $dbstatus \n" if !$WWW;

  if ($WWW)
  {
    $www_bgcolor = "pink";
    $www_bgcolor = "lime" if $dbstatus eq "UP";

    &msg("WWW Status Summary:");
    print "<table border=1 \n";
    print "<tr bgcolor=slate><th><h5>Item<th><h5>Status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Hostname<td><h5>$host\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>ORACLE_SID<td><h5>$os\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>DB Status<td><h5>$dbstatus\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Listener Status<td><h5>$lsnr_status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Logins?<td><h5>$log\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Database Space Alloc.<td><h5>$tot_spacealloc mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Database Space Used<td><h5>$tot_spaceused mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Oracle Version<td><h5>$ver\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>CPU Info<td><h5>$cpu $cpumodel\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>CPU Count<td><h5>$numcpus\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>RAM Size<td><h5>$ram mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>OS Version<td><h5>$osver\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Server Up Time<td><h5>$uptime\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Remote Shell Service<td><h5>$rsh_service\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>DB Startup Timestamp:<td><h5>$str_c\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Days DB Up:<td><h5>$uptime_days\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Hours DB Up:<td><h5>$uptime_hours\n";
    print "</table>\n";

    &msg("Listener Status: $listener_output");

    &msg("Done");
    &msg("END_OF_PROBE");
    #exit 0;
  }
}

# ----------------------------------------------------------------------
sub bkrun
# ----------------------------------------------------------------------
{
  $cmd = $arg1;
  print "$P bkrun: Issuing at now command to run backup:\n";
  print "$P bkrun: Command before {SID} substitution: $cmd\n";
  $cmd =~ s/\{SID\}/$os/g;
  $cmd = "echo 'time $cmd' | at now";
  print "$P bkrun: About to issue: $cmd\n";
  $rc = system($cmd);
  print "$P bkrun: Back from issuing at now - rc=$rc\n";
}

# ----------------------------------------------------------------------
sub bkup
# ----------------------------------------------------------------------
{
  # use strict;
  use DBI;

  print "$P | Connecting to Oracle driver=$driver\n";
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass")
    || &dbError("Connect_To_DB");

  $sql = "select table_name from dba_tables where owner='DBAMON' and 
          table_name='BACKUP_AGE'";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
     $bat_exists = "true";   
  }
 
  if ($bat_exists eq "true")
  {
     # Read from dbamon.backup_age
     $sql = "select bcklevel, max(tsnum),tstext,elapsed 
       from 
         dbamon.backup_age
       where 
         sid =\'$os\' and bcklevel !=\'ARC\' 
         group by tstext,bcklevel,elapsed
         order by 2,3";
     $sth = $dbh->prepare("$sql") || &dbError("Prepare");
     ##$sth->execute || &dbError("Execute_Select");
     $sth->execute;
     print "=======================================================\n";
     print "Backups Found in dbamon.backup_age:\n\n";

     $lvlage = 99999999;  # Age in hours of most recent LVL? backup
     while (@Data = $sth->fetchrow_array)
     {
       $bcklevel = $Data[0];
       $maxts    = $Data[1];
       $c_date   = $Data[2];
       $e_time   = $Data[3];
       $now = time();
       $agehrs   = ($now - $maxts) / 3600;
       $agehrs   = sprintf("%.0f", $agehrs);
       print "$P BACKUP_AGE: $bcklevel $agehrs - Timestamp=$c_date\n";
       if (substr($bcklevel,0,3) eq "LVL")
       {
          $bktype = "bkRMAN";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
       if (substr($bcklevel,0,3) eq "EXP")
       {
          $bktype = "bkEXP";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
       if (substr($bcklevel,0,3) eq "TBS")
       {
          $bktype = "bkTBS";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
     }
     print "BckAge: $lvlage Type: $bktype CompletionTime: $c_date ElapsedMinutes: $e_time\n"; 
     $flag = 1;
  } 
  else
  {
     # Read from v$datafile;
     $sql = "select 
         s.backup_type, 
         s.incremental_level,
         to_char(s.completion_time,'YYYY/MM/DD-HH24:MI:SS'),
         s.elapsed_seconds / 60,
         (sysdate - s.completion_time) * 24
       from 
         v\$backup_set s
       where 
         s.backup_type in ('D','I')
       order by 5 desc
       ";
     $sth = $dbh->prepare("$sql") || &dbError("Prepare");
     $sth->execute || &dbError("Execute_Select");
     print "=======================================================\n\n";
     print "Backups Found in v\$backup_set:\n\n";
     while (@Data = $sth->fetchrow_array)
     {
       $ty = $Data[0];
       $lv = $Data[1];
       $ct = $Data[2];
       $es = int($Data[3]);
       $ag = int($Data[4]);
       print "BckAge: $ag Type: $ty Level: $lv CompletionTime: $ct ElapsedMinutes: $es\n";
       $flag = 1;
     }
   }
  if (!$flag)
  {
    print "BckAge: -1\n";
  }
  print "=======================================================\n";
}

# ----------------------------------------------------------------------
sub bkhi
# ----------------------------------------------------------------------
{
  &msg("Selecting from DBAMON.BACKUP_AGE");

  # use strict;
  use DBI;

  &msg("Connecting to Oracle driver=$driver");
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  # Read from dbamon.backup_age
  $sql = "select 
      bcklevel, 
      tstext, 
      tsnum, 
      dbsize, 
      elapsed 
    from 
      dbamon.backup_age
    where 
      sid =\'$os\'
    order 
      by 2 desc";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute;

  $lvlage = 99999999;  # Age in hours of most recent LVL? backup
  print "<font face='Trebuchet MS'> <table bgcolor=slate> <tr>
    <th><font size=2>Backup<br>Type
    <th><font size=2>Completion<br>Timestamp
    <th><font size=2>DB Size<br>(MB Used)
    <th><font size=2>Backup Duration<br>(Minutes)
    <th><font size=2>Age Of<br>This Backup<br>(Hours) 
  ";

  $rowcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $bcklevel = $Data[0];
    $tstext   = $Data[1];
    $tsnum    = $Data[2];
    $dbsize   = $Data[3];
    $elapsed  = $Data[4];

    $now = time();
    $agehrs   = ($now - $tsnum) / 3600;
    $agehrs   = sprintf("%.0f", $agehrs);

    $elapsed_min = $elapsed / 60;
    $elapsed_min = sprintf("%.2f", $elapsed_min);

    $rowcount++;

    print "<tr bgcolor=lightblue>
      <td><font size=2><b>$bcklevel
      <td><font size=2><b>$tstext
      <td align=right><font size=2><b>$dbsize
      <td align=right><font size=2><b>$elapsed_min
      <td align=right><font size=2><b>$agehrs
    \n";
  }
  print "</table>";
  &msg("Total Backups Found: $rowcount\n");
}

# ----------------------------------------------------------------------
sub perf
# ----------------------------------------------------------------------
{
  ## &msg("Connecting to Oracle driver=$driver");
  ## $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  &msg("Running SQL to collect perf data");

  $sql = '
  alter session set NLS_NUMERIC_CHARACTERS = \'.,\';
  select
    \'F\', count(*) from v\$bh where status = \'free\';
  select
    \'P\',
    name,
    100* (1-(physical_reads / (DB_BLOCK_GETS + CONSISTENT_GETS)))
  from
    v\$buffer_pool_statistics;
  select
    \'V\', 
    round((sum(gethits) / sum(gets) * 100),2),
    sum(gets)
     from v\$librarycache;
  select 
    \'U\', 
    round((sum(gets) - sum(getmisses)) / sum(gets) * 100,2),
    sum(gets)
     from v\$rowcache;
  select
    \'R\', bytes from v\$sgastat where name = \'free memory\' and pool = \'shared pool\';
  select
    \'S\', value from v\$parameter where name = \'shared_pool_size\';
  select
    \'T\', value from v\$parameter where name = \'db_block_buffers\';
  select
    \'J\', value from v\$parameter where name = \'db_block_size\';
 select
    \'K\', value from v\$parameter where name = \'spfile\';
  select
    \'Q\', value from v\$parameter where name = \'db_cache_size\';
  select
    \'X\', value from v\$parameter where name = \'sql_trace\';
  select 
    \'W\',
       sum(decode(name, \'consistent gets\', value, 0)) consistent,
       sum(decode(name, \'db block gets\',   value, 0)) db_blockgets,
       sum(decode(name, \'physical reads\',  value, 0)) physical,
       round(((sum(decode(name, \'consistent gets\', value, 0)) +
               sum(decode(name, \'db block gets\',   value, 0)) -
               sum(decode(name, \'physical reads\',  value, 0))) /
              (sum(decode(name, \'consistent gets\', value, 0)) +
               sum(decode(name, \'db block gets\',   value, 0)))) * 100, 2)
    hitratio from v\$sysstat;
  select
    \'Z\',
    100* (1-(sum(physical_reads) / (sum(DB_BLOCK_GETS) + sum(CONSISTENT_GETS))))
  from
    v\$buffer_pool_statistics
  where
    (db_block_gets + consistent_gets) > 0
    and name != \'RECYCLE\';
  ';

  #unused# $sqlgood = 0;
  $free_buffers = -1;

  &oraSQL($sql);
  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb  = $words[0];
    
    if ($verb eq "F")
    {
      print "F $words[1]\n";
      $free_buffers = $words[1];
    }

    if ($verb eq "R")
    {
      ##print "R $words[1]\n";
      $sg_free = $words[1];
    }

    if ($verb eq "S")
    {
      ##print "S $words[1]\n";
      $sg_size = $words[1];
      if ($sg_size =~ /M$/)
      {
        chop($sg_size);
        $sg_size *= 2**20;
      }
    }

    if ($verb eq "T")
    {
      $db_block_buffers = $words[1];
    }

    if ($verb eq "J")
    {
      $db_block_size = $words[1];
    }

    if ($verb eq "K")
    {
      $spfile = $words[1];
    }

    if ($verb eq "Q")
    {
      $db_cache_size = $words[1];
    }

    if ($verb eq "X")
    {
      $sql_trace = $words[1];
    }

    if ($verb eq "P")
    {
      $pool_keep_hitratio    = $words[2] if $words[1] eq "KEEP";
      $pool_recycle_hitratio = $words[2] if $words[1] eq "RECYCLE";
      $pool_default_hitratio = $words[2] if $words[1] eq "DEFAULT";
    }

    if ($verb eq "W") 
    { 
      $bufcongets   = $words[1];
      $bufblkgets   = $words[2];
      $bufphysreads = $words[3];
      $bufhitratio  = $words[4];
    }

    if ($verb eq "Z") 
    { 
      $bufhitratio_xr   = $words[1];
    }

    if ($verb eq "V") 
    { 
      $libcachehitratio = $words[1];
      $libcachegets     = $words[2];
    }

    if ($verb eq "U") 
    { 
      $dictcachehitratio = $words[1];
      $dictcachegets     = $words[2];
    }
  }
  #unused# close(INDB);

  #Edits
  $pool_default_hitratio = sprintf("%.2f", $pool_default_hitratio) if $pool_default_hitratio ne "";
  $pool_recycle_hitratio = sprintf("%.2f", $pool_recycle_hitratio) if $pool_recycle_hitratio ne "";
  $pool_keep_hitratio    = sprintf("%.2f", $pool_keep_hitratio)    if $pool_keep_hitratio ne "";

  if ($sg_size > 0)
  {
    $sg_pct = 100 - (($sg_free / $sg_size) * 100);
  }
  else
  {
    $sg_pct = ".";
  }

  chop($num_otrace = `ls -l \$ORACLE_HOME/otrace/admin/*.dat 2>/dev/null | wc -l`); 

  print "$P SGA:              $sg_pct $sg_size $sg_free \n";
  print "$P POOL_DEFAULT_HR:  $pool_default_hitratio\n"; 
  print "$P POOL_RECYCLE_HR:  $pool_recycle_hitratio\n"; 
  print "$P POOL_KEEP_HR:     $pool_keep_hitratio\n"; 
  print "$P BUFBLKGETS:       $bufblkgets\n"; 
  print "$P BUFCONGETS:       $bufcongets\n"; 
  print "$P BUFPHYSREADS:     $bufphysreads\n"; 
  print "$P BUFHITRATIO:      $bufhitratio\n"; 
  print "$P BUFHITRATIO_XR:   $bufhitratio_xr\n"; 
  print "$P LIBHITRATIO:      $libcachehitratio\n"; 
  print "$P LIBGETS:          $libcachegets\n"; 
  print "$P DICTHITRATIO:     $dictcachehitratio\n"; 
  print "$P DICTGETS:         $dictcachegets\n"; 
  print "$P DB_BLOCK_BUFFERS: $db_block_buffers\n"; 
  print "$P DB_BLOCK_SIZE:    $db_block_size\n"; 
  print "$P DB_CACHE_SIZE:    $db_cache_size\n"; 
  print "$P NUM_OTRACE:       $num_otrace\n"; 
  print "$P SQL_TRACE:        $sql_trace\n"; 
  print "$P FREE_BUFFERS:     $free_buffers\n"; 
  print "$P SPFILE:           $spfile\n"; 

  # Find the names of suitable USER* and TEMP* tablespaces
  &msg("Looking for suitable USER* and TEMP* tablespaces");
  $sql = '
    select
      \'USER_TS\',
      ts.tablespace_name
    from
      dba_tablespaces ts
    where
      ts.tablespace_name like \'USER%\'
    order by
      1 ;

    select
      \'ALT_USER_TS\',
      us.default_tablespace,
      count(*) 
    from
      dba_users us
    where 
      us.default_tablespace != \'SYSTEM\'
    group by
      \'ALT_USER_TS\',
      us.default_tablespace
    order by 3 desc
      ;

    select
      \'ALT_TEMP_TS\',
      us.temporary_tablespace,
      count(*) 
    from
      dba_users us
    where 
      us.temporary_tablespace != \'SYSTEM\'
    group by
      \'ALT_TEMP_TS\',
      us.temporary_tablespace
    order by 3 desc
      ;

    select
      \'TEMP_TS\',
      ts.tablespace_name
    from
      dba_tablespaces ts
    where
      ts.tablespace_name like \'TEMP%\'
      and ts.contents = \'TEMPORARY\'
    order by
      1; ';

  &oraSQL($sql);
  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    
    if ($verb eq "TEMP_TS" && $good_temp_ts eq "")
    {
      $good_temp_ts = $words[1];
      print "good_temp_ts=$good_temp_ts\n";
    }
    if ($verb eq "USER_TS" && $good_users_ts eq "")
    {
      $good_users_ts = $words[1];
      print "good_users_ts=$good_users_ts\n";
    }
    if ($verb eq "ALT_USER_TS" && $alt_users_ts eq "")
    {
      $alt_users_ts = $words[1];
      print "alt_users_ts=$alt_users_ts\n";
    }
    if ($verb eq "ALT_TEMP_TS" && $alt_temp_ts eq "")
    {
      $alt_temp_ts = $words[1];
      print "alt_temp_ts=$alt_temp_ts\n";
    }
  }

  if ($good_users_ts eq "") { $good_users_ts = $alt_users_ts; }
  if ($good_temp_ts eq "")  { $good_temp_ts  = $alt_temp_ts; }

  if ($good_temp_ts eq "" || $good_temp_ts eq "")  
  { 
    system("echo ' ' | mailx -s 'DBAmon | perf() temp=$good_temp_ts users=$good_users_ts alt_users_ts=$alt_users_ts alt_temp_ts=$alt_temp_ts dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
  }

  print "$P GOOD_USERS_TS: $good_users_ts\n";
  print "$P GOOD_TEMP_TS:  $good_temp_ts\n";

  # START - TEMP FIX - there are many DB's where there is a RPT user that keeps 
  #  getting set to temp=tools; Try to fix that. 

  &oraSQL("select 'X' from dba_users where username = 'RPT' and TEMPORARY_TABLESPACE = 'TOOLS';");
  &msg("Looking for RPT user with TOOLS as temporary tablespace");
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      &msg("Altering RPT to set temporary tablespace to TEMP");
      &oraSQL("alter user RPT temporary tablespace TEMP;");
    }
  }

  # END   - TEMP FIX - there are many DB's where there is a RPT user that keeps 
  #  getting set to temp=tools; Try to fix that. 

  &msg("Done collecting user exception data - temp=$good_temp_ts users=$good_users_ts alt_users_ts=$alt_users_ts alt_temp_ts=$alt_temp_ts");

  #---- User exceptions - Fix 
  ## &userException("Fix");

  #---- User exceptions - Report 
  ## &userException("Report");

  #---- Collect ts exception data
  &msg("Running SQL to find tablespaces in exception status");
  $sql = '

    select
      \'TEMP_PERM\',
      ts.tablespace_name
    from
      dba_tablespaces ts
    where
      tablespace_name = \'TEMP\'
      and ts.contents = \'PERMANENT\'
      ;
  ';

  &oraSQL($sql);
  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    
    if (
        $verb eq "TEMP_PERM" 
       )
    {
      $ts   = $words[1];
      print "$P TS_EXCEPTION: $verb: $ts\n";
    }
  }
  &msg("Done collecting tablespace exception data");

  &perfRollback;

  &msg("Done collecting perf data");
}

# ----------------------------------------------------------------------
sub perfRollback
# ----------------------------------------------------------------------
{
  &msg("Checking rollback segments");
  #
  # Check for rollback segment header waits
  #

  $sqlstmt = 'select \'X\', 
    rn.NAME,
    rs.EXTENTS,
    rs.EXTENDS,
    rs.RSSIZE,
    rs.XACTS,
    rs.GETS,
    rs.HWMSIZE,
    rs.WRAPS,
    rs.AVEACTIVE,
    rs.STATUS,
    rs.WAITS,
    rs.optsize
  from 
    v\$rollstat rs, 
    v\$rollname rn 
  where 
    rn.usn=rs.usn;';

  print "Name          Extents  Extends         RSSize   A Xn's      Gets         HWMSize  Wraps   Avg Actv  Status   Waits Optimal\n";
  print "------------ -------- -------- -------------- -------- ---------- -------------- ------  --------- -------- ------ -------\n";

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words     = split();
    $verb      = $words[0];
    $name      = $words[1];
    $extents   = $words[2];
    $extends   = $words[3];
    $rssize    = $words[4];
    $xacts     = $words[5];
    $num_gets  = $words[6];
    $hwmsize   = $words[7];
    $wraps     = $words[8];
    $aveactive = $words[9];
    $status    = $words[10];
    $waits     = $words[11];
    $optimal   = $words[12];
    if ($verb eq "X")
    {
      printf "%-12s %8d %8d %14d %8d %10d %14d %6s %10d %-8s %6d %-8s\n",
        $name,$extents,$extends,$rssize,$xacts,$num_gets,$hwmsize,$wraps,$aveactive,$status,$waits,$optimal;
      $t_waits += $waits;
      $t_gets  += $num_gets;
    }
  }

  $waits_gets_r = 100 * ($t_waits/$t_gets) if $t_gets > 0;
  $waits_gets_r = sprintf("%8.5f",$waits_gets_r);

  print "$P Rollback_Total_Waits:   $t_waits\n";
  print "$P Rollback_Total_Gets:    $t_gets\n";
  print "$P Rollback_Waits_To_Gets: $waits_gets_r%\n";

  if ($waits_gets_r > 1)
  {
    &msg("Because the ratio is > 1, add more rollback segments");
  }
}

#------------------------------------------------------------------------------
sub oraSQL
#------------------------------------------------------------------------------
{
  my $os_sql = $_[0];

  if ($os_sql eq "") { &error("Null SQL passed to oraSQL"); }

  if ($sqlcmd eq "sp")
  {
    $os_scmd = "sqlplus /NOLOG";
    $os_conn = "connect / as sysdba ";
    $os_set  = "set linesize 9999;";
    $os_end  = "/";
  }
  else
  {
    $os_scmd = "svrmgrl";
    $os_conn = "connect internal ";
    $os_set  = "";
    $os_end  = "";
  }
  &msg("os_scmd=$os_scmd os_conn=$os_conn");
  $os_sql =~ s/\\//g;
  &msg("DEBUG os_sql=$os_sql") if $debug;

  open(SQLOUT,">$tmpsql") || &error("Cannot open output tmpsql=$tmpsql - $!");
  print SQLOUT "$os_conn\n";
  print SQLOUT "$os_set\n";
  print SQLOUT "$os_sql\n";
  print SQLOUT ";\n";
  print SQLOUT "exit\n";
  close(SQLOUT);

  &msg("Running: $os_scmd \@$tmpsql");

  ##system("set"); 
  ##system("$os_scmd \@$tmpsql");

  @oraSQLout = `$os_scmd \@$tmpsql`;
}


# ----------------------------------------------------------------------
#
# Main
#
# ----------------------------------------------------------------------

$stime = time;

#
# Check to see if Oracle is 
#
if ($verb eq "up") 
{
  $subrc = &up();
  $subrc = &ts();
  $subrc = &perf();
  $subrc = &controlFiles();
  $subrc = &redoLogs();
}

#
# Check to see if the listener is up - start it if not
#
if ($verb eq "datafiles") 
{
  $subrc = &datafiles();
}

#
# Backup age
#
if ($verb eq "bkup")
{
  $subrc = &bkup();
}

#
# Archive logs 
#
if ($verb eq "arclogs")
{
  $subrc = &arclogs();
}

#
#---- Backup menu options
#
if ($verb eq "bkhi") { $subrc = &bkhi(); }

#
# Testing
#
if ($verb eq "perftest") { $subrc = &perf(); }

#
# Terminate
#

##&msg("Capturing etime");
$etime = time;
$elapsed = $etime - $stime;

&msg("$P DoneOK - elapsed: $elapsed - subrc: $subrc");
&msg("END_OF_PROBE");
exit 0;
